// Ejemplo de programa para medir pulsos y variar velocidad con el 
//  motor del tornillo (Lazo abierto) 
//
//  ESP32 Dev Module, 38 pines
//
//  Board manager:  esp32 Espressif 3.0.7
//
//
//   fecha: 9 de diciembre del 2024
#include "RotaryEncoderPCNT.h"

#define ENCODER_A 27 // Pin for Encoder C
#define ENCODER_B 14 // Pin for Encoder D

volatile int encoder_value2 = 0; // Variable global para almacenar la posición del encoder

RotaryEncoderPCNT encoder(ENCODER_A,ENCODER_B);


// Pines para el puente H Tornillo
const int in3Pin = 2;       //  conexion IN1 (para la dirección)
const int pwmPin2 = 4;       // Pin para el PWM (variacion de velocidad)

// Definir la frecuencia y resolución del PWM
const int freq = 2000; // Frecuencia PWM en Hz
const int resolution = 8; // Resolución de 8 bits (0-255)
const int pwmChannel2 = 1;   // Canal para PWM2
int dato, aa;


void setup() {
  Serial.begin(115200); // Initialize serial communication

  pinMode(ENCODER_A, INPUT_PULLUP);
  pinMode(ENCODER_B, INPUT_PULLUP);

  pinMode(in3Pin, OUTPUT);
  pinMode(pwmPin2, OUTPUT);
  ledcAttachChannel(pwmPin2, freq, resolution, pwmChannel2);

  digitalWrite(in3Pin, LOW); // IN3 motor tornillo
}

void loop() {
  encoder_value2=encoder.position();

  Serial.print(dato/255.0);
  Serial.print(",");
  Serial.println(encoder_value2/56718.0);

  if (Serial.available()) {
    aa = Serial.parseInt();
  }
  if (aa != 0) dato = aa;  // setpoint tornillo

  // Pines direccion giro del Tornillo
  if (dato < 0) {
    digitalWrite(in3Pin, LOW);
  } else {
    digitalWrite(in3Pin, HIGH);
  }
  // Velocidad de giro
  ledcWrite(pwmPin2, abs(dato));

  delay(20);
}
